/-
    Homework 1

    100 total points:
      80 in this file (src/hw1.lean)
      20 in src/desugaring.lean
-/

/-
  In this homework, you'll do some programming in Lean and
  prove some low-level lemmas.

  Each problem should be independent of the others, but subproblems
  may depend on each other.

  Later problems aren't necessarily harder than earlier ones, so if you get
  stuck on a problem, move on and come back to it later.

  You'll know most of what you need for this homework after the first few lectures.
  Get started early so you have time to ask questions!

  For all proofs, please use the grouping curly braces "{ ... }" as shown in class.
  For this homework, we won't take points off for proof style, but we may start
  doing so in future homeworks.
-/

/-- Multiplication of natural numbers, used in Problem 1 -/
def mult : nat → nat → nat
| 0 n := 0
| (nat.succ m') n := n + (mult m' n)

/- [PROBLEM 1 (20 points)]: Prove that multiplication by 1 is the identity.
   Hint: this should be similar to add_O from Lecture 1 -/

lemma mult_1 :
  forall m,
    mult m 1 = m :=
begin
  -- TODO about 5 tactics
  admit
end

-- Decide if two nats are equal
def nat_eq : nat → nat → bool
| 0 0 := tt
| (nat.succ mp) (nat.succ np) := nat_eq mp np
| _ _ := ff

/--
  [PROBLEM 2 (20 points)]:

    a (10 points).
      Correct the definition of nat_le, which should return
      true when m is less than or equal to n and false otherwise.

      Hint: This definition should be similar to nat_eq above.

    b (10 points).
      Complete the proof of nat_eq_nat_le, which states
      that if m = n, then m <= n.

      Hint: As is often the case, you may want to induct
            before intro-ing everything.
-/

-- TODO: fix this definition
def nat_le : nat → nat → bool
| m n := bool.ff

-- Use these to test your function
#eval (nat_le 5 5) -- tt (aka, true)
#eval (nat_le 3 5) -- tt (aka, true)
#eval (nat_le 5 3) -- ff (aka, false)

theorem nat_eq_nat_le :
  forall m n,
    nat_eq m n = tt ->
    nat_le m n = tt :=
begin
  -- TODO: about 10 tactics
  --
  -- Hint: Using ";" to sequence tactics will help keep
  --       the proof shorter, but can be a little confusing
  --       because you have to think about what a tactic
  --       does in all the sub-cases.  Many times, the best
  --       way to get a short ";"-style proof is actually
  --       to work out the first couple cases in full detail,
  --       notice the repitition, and only then come back
  --       and refactor the proof to be smaller via ";".
  admit
end

-- END PROBLEM 2

-- Alternate definition of addition, used in Problem 3
def plus' : nat → nat → nat
| n 0 := n
| n (nat.succ m) := plus' (nat.succ n) m

-- A lemma that will be useful in Problem 3
lemma add_succ :
  forall m n,
  nat.add (nat.succ m) n = nat.succ (nat.add m n) :=
begin
  intros, induction n,
  { simp [nat.add] },
  { simp [nat.add], rw ih_1 }
end

/-

  [PROBLEM 3 (20 points)]:

    Finish the proof of the lemma below.
    Note that the approach shown (commented out) will not work!
    This is because it does induction "too soon", leading to
    an induction hypothesis that is too weak.

    You will most likely want to use the add_succ lemma
    proved above to finish up the inductive case.
-/

lemma plus'_add :
  forall m n,
    plus' n m = nat.add n m :=
begin
  /- won't work... -/
  -- intros,
  -- induction n,
  -- { simp [plus'] },
  -- { simp [plus'], admit }

--  TODO complete the proof (about 9 tactics)
--  HINT: don't intros before inducting!
--  Think carefully about why this matters!!
  admit
end

-- END PROBLEM 3

/- Alternate definition of multiplication, used in Problem 4 -/
def mult' : nat → nat → nat → nat
| 0 m acc := acc
| (nat.succ n) m acc := mult' n m (m + acc)

/--
  [PROBLEM 4 (20 points)]:

    Please complete the proof of mult_mult'_0 below.
    To do this, you will need to first prove a helper
    lemma.  Figuring what you need to prove is the hard
    part, but once you do, the rest of the proof should
    be much easier!
-/

/-
  TODO figure out helper lemma and prove it
  (ours took about 5 tactics)
-/

theorem mult_mult'_0 :
  forall n m,
    mult' n m 0 = mult n m :=
begin
  /-
    TODO complete this proof using your helper lemma
    (ours was about 7 tactics)
  -/
  admit
end

-- END PROBLEM 4
